// Copyright 2000 Macromedia, Inc. All rights reserved


function createFormContent(rowInfoArr,rs,col){
  var nRows = rowInfoArr.length, i,currRowInfoObj, tableRowPart;
  var displayInfo, type, leftColContents, rightColContents;
  var tableStr = "", paramObj = new Object();
  
  for (i=0;i<nRows;i++){
    currRowInfoObj = rowInfoArr[i];
    fieldInfoObj = currRowInfoObj.displayAs; // this is an object
    fieldInfoObj.fieldName = currRowInfoObj.fieldName;
    fieldType = fieldInfoObj.type; //
    
    // first, get the right row type for the form fields being displayed
    if (fieldType == "radioGroup" || fieldType == "dynamicRadioGroup") {
      tableRowPart = PART_TR_RG;
    } else if ( fieldType == "textArea") {
      tableRowPart = PART_TR_TA;
    } else {
      tableRowPart = PART_TR;
    }
    
    // next, create the html for the form widget. All form widgets are
    // defined in html files
    paramObj.leftCol = currRowInfoObj.label;
    paramObj.rightCol = createFieldCellContents(fieldInfoObj);
    tableStr += tableRowPart.getInsertString(paramObj);
  }
  
  // add last row to table that contains submit button
  var submitButtonPart = new Participant("editOps_submitButton"); 
  paramObj.buttonText = SUBMIT_BTN_TEXT;
  var submitButtonHTML = submitButtonPart.getInsertString(paramObj);
  paramObj.leftCol = "&nbsp;";
  paramObj.rightCol = submitButtonHTML;
  tableStr += PART_TR.getInsertString(paramObj);
  
  paramObj.tableContent = tableStr;
  paramObj.tableAlign   = "center";
  var tableHTML = PART_TABLE.getInsertString(paramObj);

  var hiddenFieldPartName = (EDIT_OP_TYPE == "Insert")?"insertRecord_hiddenEdit":"updateRecord_hiddenEdit";
  var hiddenFieldPart = new Participant(hiddenFieldPartName); 
  var hiddenFieldHTML = hiddenFieldPart.getInsertString();
  var formPart = new Participant("editOps_form"); 
  // need another hidden field for update record
  if ( EDIT_OP_TYPE == "Update" ){
    var hiddenFieldRecordIDPart = new Participant("editOps_hiddenRecordId"); 
    paramObj.rs = rs; 
    paramObj.col = col;
    var hiddenFieldRecordIDHTML = hiddenFieldRecordIDPart.getInsertString(paramObj);
  } 
  
  var formContent = tableHTML + hiddenFieldHTML;
  // if update, then add another hidden field to formContent;
  if (EDIT_OP_TYPE == "Update") formContent += hiddenFieldRecordIDHTML;
  
  return formContent;
  
}




function createFieldCellContents(fieldInfoObj){
  var paramObj = new Object();
  var retVal   = "";
  var fieldType = fieldInfoObj.type;
  paramObj.fieldName = fieldInfoObj.fieldName;

  switch (fieldType){
   
    case "textArea":
    case "textField":
      paramObj.fieldVal = fieldInfoObj.value;
      if (fieldType == "textArea") {
        retVal = PART_TA.getInsertString(paramObj);
      } else {  
        retVal = PART_TF.getInsertString(paramObj);
      }
      break;
     
    
    case "text": // redo this case when dynamic data XML is defined
      retVal = fieldInfoObj.text;
      break;
    
    case "menu":
      var nOptions = fieldInfoObj.textArr.length, i;
      var defaultSelected = fieldInfoObj.defaultSelected;
      paramObj.selected = "";
      
      for (i=0;i<nOptions;i++){
        paramObj.optionText = fieldInfoObj.textArr[i];
        paramObj.optionVal  = fieldInfoObj.valArr[i]
        if (defaultSelected && paramObj.optionVal){
          paramObj.expression1 = formatDynamicExpression(paramObj.optionVal);
          paramObj.expression2 = formatDynamicExpression(defaultSelected);
          paramObj.selected = PART_SELECTED_ATTR.getInsertString(paramObj);                   
        }
        retVal += PART_OPTION.getInsertString(paramObj);
        retVal = killEndingWhiteSpace(retVal);
      }
      
      // if no option is selected by default, then add "selected" to first option
      // this allows the first option to show in the ultradev wysiwyg view
      var regExp = /selected/i;
      if (retVal.search(regExp) == -1){
        regExp = /(<option[^>]*)(>)/i;
        if ( regExp.exec(retVal) != null ){
          retVal =  retVal.replace(RegExp.$2," selected>");
        }
      }
        
      paramObj.menuContent = retVal;
      
      retVal = PART_SELECT.getInsertString(paramObj);
      break;
    
    case "dynamicMenu":
      var defaultSelected = fieldInfoObj.defaultSelected;
      var menuStr = "";
      var optionPart = PART_DYN_OPTION;

      paramObj.labelColumn = fieldInfoObj.textCol;
      paramObj.valueColumn = fieldInfoObj.valCol
      paramObj.rsName = fieldInfoObj.recordset;
      setMoveToParamsForJsp(paramObj);
   
      if (defaultSelected){
        paramObj.expression1 = formatDynamicExpression(defaultSelected); 
        optionPart
      } else {
        paramObj.MM_subType = "noSelection";
        optionPart = PART_DYN_OP_NOSEL;
      
      }
 
      menuStr += PART_BEGIN_LOOP.getInsertString(paramObj);
      menuStr += optionPart.getInsertString(paramObj);
      menuStr += PART_END_LOOP.getInsertString(paramObj);
      
      paramObj.menuContent = menuStr;
      retVal = PART_SELECT.getInsertString(paramObj);
      
      break;
  
    
    case "checkBox":
    case "dynamicCheckBox":
      var checkIf = fieldInfoObj.checkIf;
      var equalTo = fieldInfoObj.equalTo;

      if (checkIf && equalTo) { // dynamic checkbox
        paramObj.expression1 = formatDynamicExpression(checkIf);
        paramObj.expression2 = formatDynamicExpression(equalTo);
        var checkedPart = new Participant("dynamicCheckbox_attrib");
        paramObj.checked = checkedPart.getInsertString(paramObj);
      } else { // static checkbox
        if (fieldInfoObj.checked){
          paramObj.checked = (fieldInfoObj.checked.toString() == "true")?"checked":"";
        } else { // needed if user only filled out 1 field in dynamic check box
          paramObj.checked = "";
        }
      }
      retVal = PART_CB.getInsertString(paramObj);
      break;
      
    
    case "radioGroup": 
       var tableContentStr = "";
       var nButtons = fieldInfoObj.labelArr.length;
       var defaultChecked = fieldInfoObj.defaultChecked;
       
       paramObj.checked = "";
       if (!nButtons) {
          var labelText = "[ " + MM.LABEL_Label + " ]";
          fieldInfoObj.labelArr = new Array(labelText,labelText);
          fieldInfoObj.valArr   = new Array("radiobutton1","radiobutton2");
          nButtons = 2;
       }
     

       for (i=0;i<nButtons;i++){
         paramObj.fieldLabel = fieldInfoObj.labelArr[i];
         paramObj.fieldVal   = fieldInfoObj.valArr[i];
         if (defaultChecked && paramObj.fieldVal){
           paramObj.expression1 = formatDynamicExpression(paramObj.fieldVal);
           paramObj.expression2 = formatDynamicExpression(defaultChecked);
           paramObj.checked =  PART_CHECKED_ATTR.getInsertString(paramObj);
         }
         tableContentStr += PART_TR_RB.getInsertString(paramObj);
      }  
      
      paramObj.tableAlign = "left";
      paramObj.tableContent = tableContentStr;
      retVal = PART_TABLE.getInsertString(paramObj);
      
      break;
      
    case "dynamicRadioGroup":
      var recordset = fieldInfoObj.recordset;
      var labelCol  = fieldInfoObj.labelCol;
      var valCol    = fieldInfoObj.valCol;
      var defaultChecked = fieldInfoObj.defaultChecked;
      var tableRowStr = "";
      
      paramObj.fieldLabel = createDynamicData(recordset,labelCol);
      paramObj.fieldVal   = createDynamicData(recordset,valCol);
      paramObj.recordset  = recordset;
      paramObj.checked    = "";
      paramObj.rsName     = recordset;
      setMoveToParamsForJsp(paramObj);
      
      if (defaultChecked && paramObj.fieldVal) {
        paramObj.expression1 = formatDynamicExpression(paramObj.fieldVal);
        paramObj.expression2 = formatDynamicExpression(defaultChecked);
        paramObj.checked     = PART_CHECKED_ATTR.getInsertString(paramObj);
      }
      
      tableRowStr += PART_BEGIN_LOOP.getInsertString(paramObj);
      tableRowStr += PART_TR_RB.getInsertString(paramObj);
      tableRowStr += PART_END_LOOP.getInsertString(paramObj);
      
      paramObj.tableAlign = "left";
      paramObj.tableContent = tableRowStr;
      retVal = PART_TABLE.getInsertString(paramObj);

      break;
    
    
    default:
      break;
  }
  
  return retVal;
    
}



